ALTER TABLE RECEREGIAO ADD
	CONSTRAINT FKPLA01017UNIDMEDIDA FOREIGN KEY (SGUNIDADE)
		REFERENCES UNIDMEDIDA (SGUNIDADE)
/
CREATE INDEX FKPLA01017UNIDMEDIDA ON RECEREGIAO (SGUNIDADE)
/
CREATE TABLE PRATREGIAO (
	NRPRATREGIAO			NUMBER 														NOT NULL,
	CDFILAUXPRAT			VARCHAR2(4)													NOT NULL,
	CDPRATO					VARCHAR2(10)												NOT NULL,
	CDREGIAO				VARCHAR2(3)													NOT NULL,
	NRPADRAOQUALIDADE		NUMBER														NOT NULL,
	NRCORPRIREGIAO			FLOAT 														NULL,
	QTPADRAOREGIAO			FLOAT 														NULL,
	NRORG 					NUMBER			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 	NOT NULL,
	IDATIVO 				VARCHAR2(1) 	DEFAULT 'S' 								NOT NULL
		CONSTRAINT CKC_IDATIVO_PRATREGIAO CHECK (IDATIVO IN ('S', 'N')),
	DTINCLUSAO 				DATE 														NULL,
	DTULTATU 				DATE 														NULL,
	NRORGINCLUSAO 			NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 	NULL,
	CDOPERINCLUSAO 			VARCHAR2(12) 	DEFAULT '1' 								NULL,
	NRORGULTATU 			NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')	NULL,
	CDOPERULTATU 			VARCHAR2(12) 	DEFAULT '1' 								NULL,
	CONSTRAINT PK_PRATREGIAO PRIMARY KEY (NRPRATREGIAO),
	CONSTRAINT UN_PRATREGIAO UNIQUE (CDFILAUXPRAT, CDPRATO, CDREGIAO, NRPADRAOQUALIDADE)
)
/
ALTER TABLE PRATREGIAO ADD
	CONSTRAINT FKPLA01018PRATO FOREIGN KEY (CDFILAUXPRAT, CDPRATO)
		REFERENCES PRATO (CDFILAUXPRAT, CDPRATO)
/
CREATE INDEX FKPLA01018PRATO ON PRATREGIAO (CDFILAUXPRAT, CDPRATO)
/
ALTER TABLE PRATREGIAO ADD
	CONSTRAINT FKPLA01019REGIAO FOREIGN KEY (CDREGIAO)
		REFERENCES REGIAO (CDREGIAO)
/
CREATE INDEX FKPLA01019REGIAO ON PRATREGIAO (CDREGIAO)
/
ALTER TABLE PRATREGIAO ADD
	CONSTRAINT FKPLA01020PADRAOQUALIDADE FOREIGN KEY (NRPADRAOQUALIDADE)
		REFERENCES PADRAOQUALIDADE (NRPADRAOQUALIDADE)
/
CREATE INDEX FKPLA01020PADRAOQUALIDADE ON PRATREGIAO (NRPADRAOQUALIDADE)
/
CREATE TABLE PREPPRAREGIAO (
	NRPREPPRAREGIAO 		NUMBER														NOT NULL,
	CDFILAUXPRAT			VARCHAR2(4)													NOT NULL,
	CDPRATO					VARCHAR2(10)												NOT NULL,
	CDREGIAO				VARCHAR2(3)													NOT NULL,
	NRPADRAOQUALIDADE		NUMBER														NOT NULL,
	NRPREPREGIAO			VARCHAR2(2)													NULL,
	IDPREPREGIAO			VARCHAR2(1)		DEFAULT '2'									NOT NULL
		CONSTRAINT CKC_IDPREPREGIAO CHECK (IDPREPREGIAO IN ('1', '2')),
	TXPREPREGIAO			CLOB														NULL,
	NMPREPREGIAO			VARCHAR2(50)												NULL,
	NRORG 					NUMBER			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 	NOT NULL,
	IDATIVO 				VARCHAR2(1) 	DEFAULT 'S' 								NOT NULL
		CONSTRAINT CKC_IDATIVO_PREPPRAREGIAO CHECK (IDATIVO IN ('S', 'N')),
	DTINCLUSAO 				DATE 														NULL,
	DTULTATU 				DATE 														NULL,
	NRORGINCLUSAO 			NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 	NULL,
	CDOPERINCLUSAO 			VARCHAR2(12) 	DEFAULT '1' 								NULL,
	NRORGULTATU 			NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')	NULL,
	CDOPERULTATU 			VARCHAR2(12) 	DEFAULT '1' 								NULL,
	CONSTRAINT PK_PREPPRAREGIAO PRIMARY KEY (NRPREPPRAREGIAO),
	CONSTRAINT UN_PREPPRAREGIAO UNIQUE (CDFILAUXPRAT, CDPRATO, CDREGIAO, NRPADRAOQUALIDADE, NRPREPREGIAO)
)
/
ALTER TABLE PREPPRAREGIAO ADD
	CONSTRAINT FKPLA01021PRATO FOREIGN KEY (CDFILAUXPRAT, CDPRATO)
		REFERENCES PRATO (CDFILAUXPRAT, CDPRATO)
/
CREATE INDEX FKPLA01021PRATO ON PREPPRAREGIAO (CDFILAUXPRAT, CDPRATO)
/
ALTER TABLE PREPPRAREGIAO ADD
	CONSTRAINT FKPLA01022REGIAO FOREIGN KEY (CDREGIAO)
		REFERENCES REGIAO (CDREGIAO)
/
CREATE INDEX FKPLA01022REGIAO ON PREPPRAREGIAO (CDREGIAO)
/
ALTER TABLE PREPPRAREGIAO ADD
	CONSTRAINT FKPLA01023PADRAOQUALIDADE FOREIGN KEY (NRPADRAOQUALIDADE)
		REFERENCES PADRAOQUALIDADE (NRPADRAOQUALIDADE)
/
CREATE INDEX FKPLA01023PADRAOQUALIDADE ON PREPPRAREGIAO (NRPADRAOQUALIDADE)
/
CREATE TABLE RECEPADQUALI (
	NRRECEPADQUALI			NUMBER 														NOT NULL,
	CDFILAUXPRAT			VARCHAR2(4)													NOT NULL,
	CDPRATO					VARCHAR2(10)												NOT NULL,
	NRPADRAOQUALIDADE		NUMBER														NOT NULL,
	CDPRODUTO				VARCHAR2(10)												NOT NULL,
	QTPRODRECPADQ			FLOAT														NOT NULL,
	VRPEFATCOCPADQ 			FLOAT 														NOT NULL,
	VRPEFATCORPADQ			FLOAT 														NOT NULL,
	SGUNIDADE				VARCHAR2(10)												NOT NULL,
	QTBRUTAPADQUNR			FLOAT 														NOT NULL,
	IDPRODBASEPADQ			VARCHAR2(1) 	DEFAULT 'N'									NOT NULL
		CONSTRAINT CKC_IDPRODBASEPADQ CHECK (IDPRODBASEPADQ IN ('S', 'N')),
	IDQTDEFIXPADQ			VARCHAR2(1) 	DEFAULT 'N'									NOT NULL
		CONSTRAINT CKC_IDQTDEFIXPADQ CHECK (IDQTDEFIXPADQ IN ('S', 'N')),
	NRORG 					NUMBER			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 	NOT NULL,
	IDATIVO 				VARCHAR2(1) 	DEFAULT 'S' 								NOT NULL
		CONSTRAINT CKC_IDATIVO_RECEPADQUALI CHECK (IDATIVO IN ('S', 'N')),
	DTINCLUSAO 				DATE 														NULL,
	DTULTATU 				DATE 														NULL,
	NRORGINCLUSAO 			NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 	NULL,
	CDOPERINCLUSAO 			VARCHAR2(12) 	DEFAULT '1' 								NULL,
	NRORGULTATU 			NUMBER 			DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')	NULL,
	CDOPERULTATU 			VARCHAR2(12) 	DEFAULT '1' 								NULL,
	CONSTRAINT PK_RECEPADQUALI PRIMARY KEY (NRRECEPADQUALI),
	CONSTRAINT UN_RECEPADQUALI UNIQUE (CDFILAUXPRAT, CDPRATO, NRPADRAOQUALIDADE, CDPRODUTO)
)